package net.weasel.HelpCenter;
import java.io.IOException;
import org.bukkit.entity.Player;
import org.bukkit.event.Event.Type;
import org.bukkit.event.player.PlayerEvent;
import org.bukkit.event.player.PlayerChatEvent;
import org.bukkit.event.player.PlayerListener;
import java.util.Random;

public class HelpCenterListener extends PlayerListener
{
	public static HelpCenter plugin;
	public static Random gen = new Random();
	public static int item;
	
	public HelpCenterListener(HelpCenter instance)
	{
		plugin = instance;
	}
	
	public void onPlayerJoin(PlayerEvent event)
	{
		Player player = event.getPlayer();
		
		if( event.getType() == Type.PLAYER_JOIN )
		{
			try 
			{
				String result = HelpCenter.getHelpFile(player.getDisplayName().toString(), "welcome");
				CharSequence chk = "No help found for ";
				
				if( result.contains(chk) != true )
				{
					player.sendMessage( result );
				}
			} 
			
			catch (IOException e) 
			{
				e.printStackTrace();
			}
		}
	}
	
	public void onPlayerCommand(PlayerChatEvent event)
	{
		String[] split = event.getMessage().split(" ");
		Player player = event.getPlayer();

		if( split.length == 1 )
		{
			String defaultHelp;
			try 
			{
				defaultHelp = HelpCenter.getHelpFile(player.getName(), "HCdefault" );
			} 
			catch (IOException e) 
			{
				e.printStackTrace();
				return;
			}
			
			CharSequence chk = "No help found for";
			
			if( defaultHelp.contains(chk) != true )
			{
				CharSequence cr = "\n";
				String[] dHelps = defaultHelp.split( "#!HELP" );
				
				item = gen.nextInt(dHelps.length);
				String helpItem = dHelps[item];
				
				String[] lines = helpItem.split(cr.toString());
				
				for( int x = 0; x <= lines.length - 1; x++ )					
				{
					player.sendMessage( lines[x] );
				}
				
				event.setCancelled(true);
			}
			else
			{
			    return;
			}
			
			event.setCancelled(true);

			return;
		}
		
		if((split[0].equalsIgnoreCase("/help")) || (split[0].equalsIgnoreCase("/?")))
		{
			split[0] = "";
			String args = null;
			StringBuffer argbuf = new StringBuffer();

			for( int x = 1; x <= split.length - 1; x++ )
			{
				argbuf.append( split[x] );
				argbuf.append( " " );
			}
			
			args = argbuf.toString();
			
			try 
			{
				CharSequence cr = "\n";
				String contents = HelpCenter.getHelpFile( player.getDisplayName(), args.trim() );
				
				if( contents.contains(cr) == true )
				{
					String[] lines = contents.split(cr.toString());
					
					for( int x = 0; x <= lines.length - 1; x++ )					
					{
						player.sendMessage( lines[x] );
					}
					
					event.setCancelled(true);
				}
				else
				{
					player.sendMessage( contents );
					event.setCancelled(true);
				}				
			} 
			
			catch (IOException e) 
			{
				player.sendMessage( "Unable to load helpfile." );
				event.setCancelled(true);
				e.printStackTrace();
			}
		}
	}
}
